-- 3D City Database - The Open Source CityGML Database
-- http://www.3dcitydb.org/
-- 
-- Copyright 2013 - 2018
-- Chair of Geoinformatics
-- Technical University of Munich, Germany
-- https://www.gis.bgu.tum.de/
-- 
-- The 3D City Database is jointly developed with the following
-- cooperation partners:
-- 
-- virtualcitySYSTEMS GmbH, Berlin <http://www.virtualcitysystems.de/>
-- M.O.S.S. Computer Grafik Systeme GmbH, Taufkirchen <http://www.moss.de/>
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
--     
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
--

--// ENTRIES INTO USER_SDO_GEOM_METADATA WITH BOUNDING VOLUME WITH 10000km EXTENT FOR X,Y AND 11km FOR Z

SET SERVEROUTPUT ON
SET FEEDBACK ON

ALTER SESSION set NLS_TERRITORY='AMERICA';
ALTER SESSION set NLS_LANGUAGE='AMERICAN';

CREATE INDEX ADDRESS_POINT_SPX ON ADDRESS (MULTI_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BREAKLINE_BREAK_SPX ON BREAKLINE_RELIEF (BREAK_LINES) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BREAKLINE_RIDGE_SPX ON BREAKLINE_RELIEF (RIDGE_OR_VALLEY_LINES) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD1TERR_SPX ON BRIDGE (LOD1_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD2CURVE_SPX ON BRIDGE (LOD2_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD2TERR_SPX ON BRIDGE (LOD2_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD3CURVE_SPX ON BRIDGE (LOD3_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD3TERR_SPX ON BRIDGE (LOD3_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD4CURVE_SPX ON BRIDGE (LOD4_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_LOD4TERR_SPX ON BRIDGE (LOD4_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONSTR_LOD1TERR_SPX ON BRIDGE_CONSTR_ELEMENT (LOD1_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONSTR_LOD2TERR_SPX ON BRIDGE_CONSTR_ELEMENT (LOD2_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONSTR_LOD3TERR_SPX ON BRIDGE_CONSTR_ELEMENT (LOD3_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONSTR_LOD4TERR_SPX ON BRIDGE_CONSTR_ELEMENT (LOD4_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD1REFPT_SPX ON BRIDGE_CONSTR_ELEMENT (LOD1_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD1XGEOM_SPX ON BRIDGE_CONSTR_ELEMENT (LOD1_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD2REFPT_SPX ON BRIDGE_CONSTR_ELEMENT (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD2XGEOM_SPX ON BRIDGE_CONSTR_ELEMENT (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD3REFPT_SPX ON BRIDGE_CONSTR_ELEMENT (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD3XGEOM_SPX ON BRIDGE_CONSTR_ELEMENT (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD4REFPT_SPX ON BRIDGE_CONSTR_ELEMENT (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_CONST_LOD4XGEOM_SPX ON BRIDGE_CONSTR_ELEMENT (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_FURN_LOD4REFPT_SPX ON BRIDGE_FURNITURE (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_FURN_LOD4XGEOM_SPX ON BRIDGE_FURNITURE (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_INST_LOD2REFPT_SPX ON BRIDGE_INSTALLATION (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_INST_LOD2XGEOM_SPX ON BRIDGE_INSTALLATION (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_INST_LOD3REFPT_SPX ON BRIDGE_INSTALLATION (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_INST_LOD3XGEOM_SPX ON BRIDGE_INSTALLATION (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_INST_LOD4REFPT_SPX ON BRIDGE_INSTALLATION (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_INST_LOD4XGEOM_SPX ON BRIDGE_INSTALLATION (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_OPEN_LOD3REFPT_SPX ON BRIDGE_OPENING (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BRIDGE_OPEN_LOD4REFPT_SPX ON BRIDGE_OPENING (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD1TERR_SPX ON BUILDING (LOD1_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD2CURVE_SPX ON BUILDING (LOD2_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD2TERR_SPX ON BUILDING (LOD2_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD3CURVE_SPX ON BUILDING (LOD3_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD3TERR_SPX ON BUILDING (LOD3_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD4CURVE_SPX ON BUILDING (LOD4_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BUILDING_LOD4TERR_SPX ON BUILDING (LOD4_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_FURN_LOD4REFPT_SPX ON BUILDING_FURNITURE (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_FURN_LOD4XGEOM_SPX ON BUILDING_FURNITURE (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_INST_LOD2REFPT_SPX ON BUILDING_INSTALLATION (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_INST_LOD2XGEOM_SPX ON BUILDING_INSTALLATION (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_INST_LOD3REFPT_SPX ON BUILDING_INSTALLATION (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_INST_LOD3XGEOM_SPX ON BUILDING_INSTALLATION (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_INST_LOD4REFPT_SPX ON BUILDING_INSTALLATION (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX BLDG_INST_LOD4XGEOM_SPX ON BUILDING_INSTALLATION (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITYMODEL_ENVELOPE_SPX ON CITYMODEL (ENVELOPE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITYOBJECT_ENVELOPE_SPX ON CITYOBJECT (ENVELOPE) INDEXTYPE IS MDSYS.SPATIAL_INDEX 
PARALLEL;

CREATE INDEX GROUP_XGEOM_SPX ON CITYOBJECTGROUP (OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD1REFPNT_SPX ON CITY_FURNITURE (LOD1_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD1TERR_SPX ON CITY_FURNITURE (LOD1_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD1XGEOM_SPX ON CITY_FURNITURE (LOD1_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD2REFPNT_SPX ON CITY_FURNITURE (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD2TERR_SPX ON CITY_FURNITURE (LOD2_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD2XGEOM_SPX ON CITY_FURNITURE (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD3REFPNT_SPX ON CITY_FURNITURE (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD3TERR_SPX ON CITY_FURNITURE (LOD3_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD3XGEOM_SPX ON CITY_FURNITURE (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD4REFPNT_SPX ON CITY_FURNITURE (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD4TERR_SPX ON CITY_FURNITURE (LOD4_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX CITY_FURN_LOD4XGEOM_SPX ON CITY_FURNITURE (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD0REFPNT_SPX ON GENERIC_CITYOBJECT (LOD0_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD0TERR_SPX ON GENERIC_CITYOBJECT (LOD0_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD0XGEOM_SPX ON GENERIC_CITYOBJECT (LOD0_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD1REFPNT_SPX ON GENERIC_CITYOBJECT (LOD1_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD1TERR_SPX ON GENERIC_CITYOBJECT (LOD1_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD1XGEOM_SPX ON GENERIC_CITYOBJECT (LOD1_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD2REFPNT_SPX ON GENERIC_CITYOBJECT (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD2TERR_SPX ON GENERIC_CITYOBJECT (LOD2_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD2XGEOM_SPX ON GENERIC_CITYOBJECT (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD3REFPNT_SPX ON GENERIC_CITYOBJECT (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD3TERR_SPX ON GENERIC_CITYOBJECT (LOD3_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD3XGEOM_SPX ON GENERIC_CITYOBJECT (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD4REFPNT_SPX ON GENERIC_CITYOBJECT (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD4TERR_SPX ON GENERIC_CITYOBJECT (LOD4_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX GEN_OBJECT_LOD4XGEOM_SPX ON GENERIC_CITYOBJECT (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX MASSPOINT_RELIEF_SPX ON MASSPOINT_RELIEF (RELIEF_POINTS) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX OPENING_LOD3REFPT_SPX ON OPENING (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX OPENING_LOD4REFPT_SPX ON OPENING (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX RELIEF_COMP_EXTENT_SPX ON RELIEF_COMPONENT (EXTENT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD1REFPT_SPX ON SOLITARY_VEGETAT_OBJECT (LOD1_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD1XGEOM_SPX ON SOLITARY_VEGETAT_OBJECT (LOD1_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD2REFPT_SPX ON SOLITARY_VEGETAT_OBJECT (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD2XGEOM_SPX ON SOLITARY_VEGETAT_OBJECT (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD3REFPT_SPX ON SOLITARY_VEGETAT_OBJECT (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD3XGEOM_SPX ON SOLITARY_VEGETAT_OBJECT (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD4REFPT_SPX ON SOLITARY_VEGETAT_OBJECT (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SOL_VEG_OBJ_LOD4XGEOM_SPX ON SOLITARY_VEGETAT_OBJECT (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SURFACE_DATA_SPX ON SURFACE_DATA (GT_REFERENCE_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX SURFACE_GEOM_SOLID_SPX ON SURFACE_GEOMETRY (SOLID_GEOMETRY) INDEXTYPE IS MDSYS.SPATIAL_INDEX 
PARAMETERS ('sdo_indx_dims=3') 
PARALLEL;

CREATE INDEX SURFACE_GEOM_SPX ON SURFACE_GEOMETRY (GEOMETRY) INDEXTYPE IS MDSYS.SPATIAL_INDEX 
PARALLEL;

CREATE INDEX TIN_RELF_BREAK_SPX ON TIN_RELIEF (BREAK_LINES) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TIN_RELF_CRTLPTS_SPX ON TIN_RELIEF (CONTROL_POINTS) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TIN_RELF_STOP_SPX ON TIN_RELIEF (STOP_LINES) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TRAN_COMPLEX_LOD0NET_SPX ON TRANSPORTATION_COMPLEX (LOD0_NETWORK) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD1TERR_SPX ON TUNNEL (LOD1_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD2CURVE_SPX ON TUNNEL (LOD2_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD2TERR_SPX ON TUNNEL (LOD2_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD3CURVE_SPX ON TUNNEL (LOD3_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD3TERR_SPX ON TUNNEL (LOD3_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD4CURVE_SPX ON TUNNEL (LOD4_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_LOD4TERR_SPX ON TUNNEL (LOD4_TERRAIN_INTERSECTION) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_FURN_LOD4REFPT_SPX ON TUNNEL_FURNITURE (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_FURN_LOD4XGEOM_SPX ON TUNNEL_FURNITURE (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_INST_LOD2REFPT_SPX ON TUNNEL_INSTALLATION (LOD2_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_INST_LOD2XGEOM_SPX ON TUNNEL_INSTALLATION (LOD2_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_INST_LOD3REFPT_SPX ON TUNNEL_INSTALLATION (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_INST_LOD3XGEOM_SPX ON TUNNEL_INSTALLATION (LOD3_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_INST_LOD4REFPT_SPX ON TUNNEL_INSTALLATION (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_INST_LOD4XGEOM_SPX ON TUNNEL_INSTALLATION (LOD4_OTHER_GEOM) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_OPEN_LOD3REFPT_SPX ON TUNNEL_OPENING (LOD3_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX TUNNEL_OPEN_LOD4REFPT_SPX ON TUNNEL_OPENING (LOD4_IMPLICIT_REF_POINT) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX WATERBODY_LOD0CURVE_SPX ON WATERBODY (LOD0_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

CREATE INDEX WATERBODY_LOD1CURVE_SPX ON WATERBODY (LOD1_MULTI_CURVE) INDEXTYPE IS MDSYS.SPATIAL_INDEX;

