-- 3D City Database - The Open Source CityGML Database
-- http://www.3dcitydb.org/
-- 
-- Copyright 2013 - 2018
-- Chair of Geoinformatics
-- Technical University of Munich, Germany
-- https://www.gis.bgu.tum.de/
-- 
-- The 3D City Database is jointly developed with the following
-- cooperation partners:
-- 
-- virtualcitySYSTEMS GmbH, Berlin <http://www.virtualcitysystems.de/>
-- M.O.S.S. Computer Grafik Systeme GmbH, Taufkirchen <http://www.moss.de/>
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
--     
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
--

\set USERNAME :username
\set USERNAME_QUOTED '\'':username'\''

\echo 'List of 3DCityDB schemas with usage privilege for "':USERNAME'":'
WITH schema_names AS (
  SELECT n.nspname AS schema_name
    FROM pg_catalog.pg_namespace n
	JOIN pg_catalog.pg_class c on n.oid = c.relnamespace
      WHERE c.relname = 'database_srs'
	    AND c.relkind = 'r'
) SELECT schema_name
    FROM schema_names
	  WHERE pg_catalog.has_schema_privilege(lower(:USERNAME_QUOTED), schema_name, 'USAGE');